<?php

function roundSlice($key, $array)
{
	$left = $middle = $right = array();

	// split array into left-middle-right
	ksort($array);
	reset($array);
	if (key($array) <= $key) {
		while (list($k, $v) = each($array)) {
			if ($k == $key) {
				$middle[$k] = $v;
				break;
			}
			$left[$k] = $v;
		}
	}
	while (list($k, $v) = each($array)) {
		$right[$k] = $v;
	}

	$right[strtotime('2030-01-01')] = array(); // gap

	// items in the pas are back order
	krsort($left);

	// align left and right
	if (count($left) > count($right)) {
		while (count($left) > count($right)) {
			end($left);
			$k = key($left);
			$right[$k] = current($left);
			unset($left[$k]);
		}
	} else {
		while (count($right) > count($left)) {
			end($right);
			$k = key($right);
			$left[$k] = $right[$k];
			unset($right[$k]);
		}
	}

	reset($left);
	reset($right);
	return array($left, $middle, $right);
}

